import objc;
import hashtable;
import std.c.stdio;

int main(char[][] args) {
	NXHashTable* class_hash = (NXHashTable*)objc_getClasses();
	NXHashState state = NXInitHashState(class_hash);
	Class klass;

	while(NXNextHashState(class_hash, &state, (void**)&klass)) {
		printf("%s\n",klass.name);
		showIvars(klass);
		showMethodGroups(klass, '-');
		showMethodGroups(klass, '+');
	}
	return 0;
}

void showIvars(Class klass) {
	int i;
	Ivar rtIvar;
	objc_ivar_list* ivarList= klass.ivars;
	if ( !(ivarList is null) && (ivarList.ivar_count > 0) ) {
		printf("   Instance Variables:\n");
		for (i=0; i < ivarList.ivar_count; ++i) {
			rtIvar = &ivarList.ivar_list[i];
			printf("    name: '%s' encodedType: '%s' offset: %d\n", rtIvar.ivar_name, rtIvar.ivar_type, rtIvar.ivar_offset);
		}
	}
}

void showMethodGroups (Class klass, char mType) {
	void* iterator = (void*)0;
	objc_method_list* mlist;
	Method currMethod;
	int j;
	mlist = class_nextMethodList(klass, &iterator);
	while ( !(mlist is null) ) {
		printf("   Methods:\n");
		for( j=0; j<mlist.method_count; ++j) {
			currMethod = &mlist.method_list[j];
			printf("    method: '%c%s' encodedReturnTypeAndArguments: '%s\n", mType, (char*)currMethod.method_name, currMethod.method_types);
		}
		mlist = class_nextMethodList(klass, &iterator);
	}
}
