module cocoa;

extern (C) {
	alias char* SEL;
	alias void* IMP;
	alias objc_class *Class;
	alias objc_object *id;
	alias objc_ivar *Ivar;
	alias objc_method *Method;
	alias objc_cache *Cache;

	void* objc_getClasses();
	objc_method_list *class_nextMethodList(Class, void **);

	struct objc_ivar {
		char* ivar_name;
		char* ivar_type;
		int ivar_offset;
	}
	
	struct objc_ivar_list {
		int ivar_count;
		objc_ivar ivar_list[999];
	}

	struct objc_method {
		SEL method_name;
		char *method_types;
		IMP method_imp;
	}

	struct objc_method_list {
		objc_method_list *obsolete;
		int method_count;
		objc_method method_list[999];
	}

	struct objc_cache {
		uint mask;
		uint occupied;
		Method buckets[1];
	}

	struct objc_protocol_list {
		objc_protocol_list *next;
		int count;
		void* list;
	}

	struct objc_class {
		objc_class *isa;
		objc_class *super_class;
		char* name;
		int vers;
		int info;
		int instance_size;
		objc_ivar_list *ivars;
		objc_method_list **methodLists;
		objc_cache *cache;
		objc_protocol_list *protocols;
	}

	struct objc_object {
		Class isa;
	}
}
